---

- hosts: control_planes
  remote_user: "{{ USER_ANSIBLE }}"
  become_method: sudo
  become_user: "{{ USER_ANSIBLE }}"
  become: yes
  vars_files:
    - ./vars/calico.yml
    - ./vars/general.yml
  tasks:
    - import_tasks: ./tasks/configure-calico.yml
    - import_tasks: ./tasks/configure-control-plane.yml

    - name: Apply calico manifest to the cluster.
      become: yes
      become_user: "{{ USER_ANSIBLE }}"
      shell: "kubectl apply -f {{ CALICO_CONFIG_PATH }}"
      args:
        chdir: $HOME

    - name: Get the token for joining the worker nodes
      become: yes
      become_user: "{{ USER_ANSIBLE }}"
      shell: kubeadm token create  --print-join-command
      register: kubernetes_join_command

    - debug:
        msg: "{{ kubernetes_join_command.stdout }}"

    - name: Create file to add node to k8s cluster
      copy:
        dest: "{{ USER_HOME_PATH }}/add_node_to_k8s_cluster.txt"
        content: "{{ kubernetes_join_command.stdout }}"

    - name: "download file to ansible server to path {{ ADD_NODE_COMMAND_FILEPATH_AT_ANSIBLE_SERVER }}"
      fetch:
        src: "{{ USER_HOME_PATH }}/add_node_to_k8s_cluster.txt"
        dest: "{{ ADD_NODE_COMMAND_FILEPATH_AT_ANSIBLE_SERVER }}"
        flat: yes